package com.landray.kmss.sys.attachment.jg;

import java.text.SimpleDateFormat;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.common.dao.HQLInfo;
import java.util.ArrayList;
import java.util.List;
import com.landray.kmss.common.model.IBaseModel;
import java.util.Date;
import com.landray.kmss.sys.attachment.model.SysAttJgDocSignature;
import net.sf.json.JSONObject;
import com.landray.kmss.util.SpringBeanUtil;
import org.slf4j.LoggerFactory;
import DBstep.iMsgServer2000;
import com.landray.kmss.common.service.IBaseService;
import org.slf4j.Logger;

public class JGWebRevision
{
    private static final Logger logger;
    private static String mainModelName;
    protected IBaseService baseServiec;
    private iMsgServer2000 MsgObj;
    
    static {
        logger = LoggerFactory.getLogger(JGWebRevision.class);
        JGWebRevision.mainModelName = "com.landray.kmss.sys.attachment.model.SysAttJgDocSignature";
    }
    
    public JGWebRevision() {
        this.MsgObj = new iMsgServer2000();
    }
    
    protected IBaseService getBaseService() {
        if (this.baseServiec == null) {
            this.baseServiec = (IBaseService)SpringBeanUtil.getBean("KmssBaseService");
        }
        return this.baseServiec;
    }
    
    private boolean SaveSignature(final JSONObject data) {
        boolean mResult = false;
        final IBaseService baseService = this.getBaseService();
        final SysAttJgDocSignature sysAttJgDocSignature = new SysAttJgDocSignature();
        sysAttJgDocSignature.setFdRecordID(data.getString("mRecordID"));
        sysAttJgDocSignature.setFdFieldName(data.getString("mFieldName"));
        sysAttJgDocSignature.setFdUserID(data.getString("mUserName"));
        sysAttJgDocSignature.setFdDateTime(new Date());
        sysAttJgDocSignature.setFdHostName(data.getString("mHostName"));
        sysAttJgDocSignature.setFdFieldValue(data.getString("mFieldValue"));
        try {
            baseService.add((IBaseModel)sysAttJgDocSignature);
            mResult = true;
        }
        catch (final Exception e) {
            e.printStackTrace();
            mResult = false;
        }
        return mResult;
    }
    
    private boolean UpdateSignature(final JSONObject data) {
        boolean mResult = false;
        final IBaseService baseService = this.getBaseService();
        try {
            final List results = this.findByRecordIdAndUserId(baseService, data.getString("mRecordID"), data.getString("mUserName"));
            for (int i = 0; i < results.size(); ++i) {
                final SysAttJgDocSignature sysAttJgDocSignature = results.get(i);
                this.updateModel(baseService, sysAttJgDocSignature, data);
            }
            mResult = true;
        }
        catch (final Exception e1) {
            e1.printStackTrace();
            mResult = false;
        }
        return mResult;
    }
    
    private List findByRecordIdAndUserId(final IBaseService baseService, final String recordID, final String userId) throws Exception {
        final List<Object> results = new ArrayList<Object>();
        final HQLInfo hql = this.getCommonHql();
        final String tableName = hql.getModelTable();
        hql.setWhereBlock(String.valueOf(tableName) + ".fdRecordID =:fdRecordID AND " + tableName + ".fdUserID =:fdUserID");
        hql.setParameter("fdRecordID", (Object)recordID);
        hql.setParameter("fdUserID", (Object)userId);
        final Object obj = baseService.findFirstOne(hql);
        if (obj != null) {
            results.add(obj);
        }
        return results;
    }
    
    private HQLInfo getCommonHql() {
        final HQLInfo hql = new HQLInfo();
        hql.setModelName(JGWebRevision.mainModelName);
        return hql;
    }
    
    private boolean UpdateSignature_Xform(final JSONObject data) {
        boolean mResult = false;
        final IBaseService baseService = this.getBaseService();
        try {
            final List results = this.findByRecordIdAndFieldName(baseService, data.getString("mRecordID"), data.getString("mFieldName"));
            for (int i = 0; i < results.size(); ++i) {
                final SysAttJgDocSignature sysAttJgDocSignature = results.get(i);
                this.updateModel(baseService, sysAttJgDocSignature, data);
            }
            mResult = true;
        }
        catch (final Exception e1) {
            e1.printStackTrace();
            mResult = false;
        }
        return mResult;
    }
    
    private List findByRecordIdAndFieldName(final IBaseService baseService, final String recordID, final String fieldName) throws Exception {
        final List<Object> results = new ArrayList<Object>();
        final HQLInfo hql = this.getCommonHql();
        final String tableName = hql.getModelTable();
        hql.setWhereBlock(String.valueOf(tableName) + ".fdRecordID =:fdRecordID AND " + tableName + ".fdFieldName =:fdFieldName");
        hql.setParameter("fdRecordID", (Object)recordID);
        hql.setParameter("fdFieldName", (Object)fieldName);
        final Object obj = baseService.findFirstOne(hql);
        if (obj != null) {
            results.add(obj);
        }
        return results;
    }
    
    private void updateModel(final IBaseService baseService, final SysAttJgDocSignature sysAttJgDocSignature, final JSONObject data) throws Exception {
        sysAttJgDocSignature.setFdDateTime(new Date());
        sysAttJgDocSignature.setFdHostName(data.getString("mHostName"));
        sysAttJgDocSignature.setFdFieldValue(data.getString("mFieldValue"));
        baseService.update((IBaseModel)sysAttJgDocSignature);
    }
    
    private String LoadSignature(final JSONObject data) {
        String mResult = "";
        final IBaseService baseService = this.getBaseService();
        try {
            final List results = this.findByRecordIdAndUserId(baseService, data.getString("mRecordID"), data.getString("mUserName"));
            if (results.size() > 0) {
                final SysAttJgDocSignature sysAttJgDocSignature = results.get(0);
                mResult = sysAttJgDocSignature.getFdFieldValue();
            }
        }
        catch (final Exception e1) {
            e1.printStackTrace();
        }
        return mResult;
    }
    
    private String LoadSignature_Xform(final JSONObject data) {
        String mResult = "";
        final IBaseService baseService = this.getBaseService();
        try {
            final List results = this.findByRecordIdAndFieldName(baseService, data.getString("mRecordID"), data.getString("mFieldName"));
            if (results.size() > 0) {
                final SysAttJgDocSignature sysAttJgDocSignature = results.get(0);
                mResult = sysAttJgDocSignature.getFdFieldValue();
            }
        }
        catch (final Exception e1) {
            e1.printStackTrace();
        }
        return mResult;
    }
    
    public boolean webRevisionIsExits(final String fdRecordID, final String fdUserID) throws Exception {
        boolean mResult = false;
        final HQLInfo hql = new HQLInfo();
        hql.setModelName(JGWebRevision.mainModelName);
        final String tableName = hql.getModelTable();
        final String whereBlock = String.valueOf(tableName) + ".fdRecordID =:fdRecordID and " + tableName + ".fdUserID =:fdUserID";
        hql.setWhereBlock(whereBlock);
        hql.setParameter("fdRecordID", (Object)fdRecordID);
        hql.setParameter("fdUserID", (Object)fdUserID);
        final IBaseService baseService = this.getBaseService();
        final List values = baseService.findList(hql);
        if (values.size() > 0) {
            mResult = true;
        }
        return mResult;
    }
    
    private byte[] ReadPackage(final HttpServletRequest request) {
        byte[] mStream = null;
        int totalRead = 0;
        int readBytes = 0;
        int totalBytes = 0;
        try {
            totalBytes = request.getContentLength();
            mStream = new byte[totalBytes];
            while (totalRead < totalBytes) {
                request.getInputStream();
                readBytes = request.getInputStream().read(mStream, totalRead, totalBytes - totalRead);
                totalRead += readBytes;
            }
        }
        catch (final Exception e) {
            JGWebRevision.logger.error(e.toString());
        }
        return mStream;
    }
    
    private void SendPackage(final HttpServletResponse response) {
        try {
            final ServletOutputStream OutBinarry = response.getOutputStream();
            OutBinarry.write(this.MsgObj.MsgVariant());
            OutBinarry.flush();
            OutBinarry.close();
        }
        catch (final Exception e) {
            JGWebRevision.logger.error(e.toString());
        }
    }
    
    public void ExecuteRun(final HttpServletRequest request, final HttpServletResponse response) {
        try {
            if ("POST".equalsIgnoreCase(request.getMethod())) {
                this.MsgObj.MsgVariant(this.ReadPackage(request));
                if ("DBSTEP".equalsIgnoreCase(this.MsgObj.GetMsgByName("DBSTEP"))) {
                    final JSONObject data = new JSONObject();
                    data.accumulate("mRecordID", (Object)this.MsgObj.GetMsgByName("RECORDID"));
                    data.accumulate("mFieldName", (Object)this.MsgObj.GetMsgByName("FIELDNAME"));
                    data.accumulate("mFieldValue", (Object)this.MsgObj.GetMsgByName("FIELDVALUE"));
                    data.accumulate("mUserName", (Object)this.MsgObj.GetMsgByName("USERNAME"));
                    data.accumulate("mDateTime", (Object)this.MsgObj.GetMsgByName("DATETIME"));
                    data.accumulate("mHostName", (Object)request.getRemoteAddr());
                    final String mOption = this.MsgObj.GetMsgByName("OPTION");
                    this.MsgObj.MsgTextClear();
                    if ("SAVESIGNATURE".equalsIgnoreCase(mOption)) {
                        if (this.webRevisionIsExits(data.getString("mRecordID"), data.getString("mUserName"))) {
                            if (data.getString("mFieldName").indexOf("Xform") > -1) {
                                if (this.UpdateSignature_Xform(data)) {
                                    this.MsgObj.SetMsgByName("STATUS", "更新成功!");
                                    this.MsgObj.MsgError("");
                                }
                                else {
                                    this.MsgObj.MsgError("保存签章信息失败!");
                                }
                            }
                            else if (this.UpdateSignature(data)) {
                                this.MsgObj.SetMsgByName("STATUS", "更新成功!");
                                this.MsgObj.MsgError("");
                            }
                            else {
                                this.MsgObj.MsgError("保存签章信息失败!");
                            }
                        }
                        else if (this.SaveSignature(data)) {
                            this.MsgObj.SetMsgByName("STATUS", "保存成功!");
                            this.MsgObj.MsgError("");
                        }
                        else {
                            this.MsgObj.MsgError("保存签章信息失败!");
                        }
                    }
                    else if ("LOADSIGNATURE".equalsIgnoreCase(mOption)) {
                        String fieldValue = "";
                        if (data.getString("mFieldName").indexOf("Xform") > -1) {
                            fieldValue = this.LoadSignature_Xform(data);
                        }
                        else {
                            fieldValue = this.LoadSignature(data);
                        }
                        this.MsgObj.SetMsgByName("FIELDVALUE", fieldValue);
                        this.MsgObj.SetMsgByName("STATUS", "调入签批数据成功!");
                        this.MsgObj.MsgError("");
                    }
                    else if ("SENDMESSAGE".equalsIgnoreCase(mOption)) {
                        final String mCommand = this.MsgObj.GetMsgByName("COMMAND");
                        String mInfo = this.MsgObj.GetMsgByName("TESTINFO");
                        JGWebRevision.logger.info(mInfo);
                        this.MsgObj.MsgTextClear();
                        this.MsgObj.MsgFileClear();
                        JGWebRevision.logger.info(mCommand);
                        if ("SELFINFO".equalsIgnoreCase(mCommand)) {
                            mInfo = "服务器端收到客户端传来的信息：“" + mInfo + "”\r\n";
                            final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                            final String currentTime = formatter.format(new Date());
                            mInfo = String.valueOf(mInfo) + "服务器端发回当前服务器时间：" + currentTime;
                            this.MsgObj.SetMsgByName("RETURNINFO", mInfo);
                        }
                        else {
                            this.MsgObj.MsgError("客户端Web发送数据包命令没有合适的处理函数![" + mCommand + "]");
                            this.MsgObj.MsgTextClear();
                            this.MsgObj.MsgFileClear();
                        }
                    }
                }
                else {
                    this.MsgObj.MsgError("客户端发送数据包错误!");
                    this.MsgObj.MsgTextClear();
                    this.MsgObj.MsgFileClear();
                }
            }
            else {
                this.MsgObj.MsgError("请使用Post方法");
                this.MsgObj.MsgTextClear();
                this.MsgObj.MsgFileClear();
            }
            this.SendPackage(response);
        }
        catch (final Exception e) {
            e.printStackTrace();
        }
    }
}
